/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   request-data-extractor.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

export {ActionIterableObject};

/**
 * Class responsible for extracting data from JSON values.
 */
declare class ActionIterableObject {

  /**
   * Source of the data split by `.` character
   */
  source: Array<String|null>|null;

  /**
   * Comparision operator
   */
  operator: String|null;

  /**
   * Comparision value
   */
  condition: String|Number|null;

  /**
   * @param opts Iterator options
   */
  constructor(opts: object|null);

  /**
   * Validates passed options and sets `valid` flag.
   *
   * @param opts Iterator options
   * @returns True when options are valid
   */
  _validate(opts: object|null): Boolean|null;
}

export {JsonExtractor};

/**
 * Class responsible for extracting data from JSON values.
 */
declare class JsonExtractor {

  /**
   * @param json JSON string or object. Strings are
   * parsed to objects.
   * @param path Path to the data.
   * @param iterator Data iterator
   */
  constructor(json: String|object|any[]|null, path: Array<String|null>|null, iterator: object|null);

  /**
   * Processes input JSON data and returns Array or Object. It returns
   * `undefined` if the data are empty, falsy or a primitive (except for JSON
   * strings).
   *
   * @param data Data to process
   * @returns JS object or undefined if conversion
   * wasn't possible.
   */
  _processJson(data: any[]|object|String|null): any[]|object|null|undefined;

  /**
   * Extracts the data for given conditions.
   *
   * @returns Data found for given conditions.
   */
  extract(): String|null|undefined;

  /**
   * Reads a value of an JSON object for given path.
   *
   * @param json JSON value to read
   * @param path Path to search for the value.
   * @returns Value for given path.
   */
  _getValue(json: object|any[]|null, path: Array<String|null>|null, iterableOptions: object|null): String|null|undefined;

  /**
   * Searches for a value in iterable object.
   *
   * @param json Iterable object
   * @param path Path for the value
   * @param opts Iterable object configuration
   * @returns Object that matches iterable condition
   * or undefined if none matches the condition.
   */
  _getIterableValue(json: object|any[]|null, path: Array<String|null>|null, opts: ActionIterableObject|null): object|null|undefined;

  /**
   * Searches for a value in Array.
   *
   * @param json Iterable object
   * @param path Path for the value
   * @param opts Iterable object configuration
   * @returns Object that matches iterable condition
   * or undefined if none matches the condition.
   */
  _getIterableValueArray(json: object|any[]|null, path: Array<String|null>|null, opts: ActionIterableObject|null): object|null|undefined;

  /**
   * Searches for a value in JS Object.
   *
   * @param json Iterable object
   * @param path Path for the value
   * @param opts Iterable object configuration
   * @returns Object that matches iterable condition
   * or undefined if none matches the condition.
   */
  _getIterableValueObject(json: object|any[]|null, path: Array<String|null>|null, opts: ActionIterableObject|null): object|null|undefined;
}

export {XmlExtractor};

/**
 * A helper class to extract data from an XML response.
 */
declare class XmlExtractor {

  /**
   * @param xml XML string.
   * @param path Path to the data.
   * @param iterator Data iterator
   */
  constructor(xml: String|null, path: Array<String|null>|null, iterator: object|null);

  /**
   * Gets a value of the XML type string for given path.
   *
   * @returns Value for given path.
   */
  extract(): String|null|undefined;

  /**
   * Gets a value for the XML document for given path.
   *
   * @param dom DOM document.
   * @param path Path to search for the value.
   * @returns Value for given path.
   */
  _getValue(dom: Document|null, path: Array<String|null>|null): String|null|undefined;

  /**
   * Reads attribute value for current path.
   *
   * @param dom DOM element object
   * @param part Current part of the path.
   * @returns Returned value for path or undefined
   * if not found.
   */
  _valueForAttr(dom: Element|null, part: Number|null): String|null|undefined;
}

export {RequestDataExtractor};

declare namespace LogicElements {

  /**
   * An element to extract data from JSON or XML responses.
   *
   * The `request` is ARC request object as described in
   * https://github.com/advanced-rest-client/api-components-api/blob/master/docs/
   * api-request-and-response.md#api-request document.
   * It should contain at lease `url`, `method`, `headers`, and `payload`
   *
   * The `response` is a "response" property of the `api-response` custom event
   * as described in
   * https://github.com/advanced-rest-client/api-components-api/blob/master/docs/
   * api-request-and-response.md#api-response.
   * It should contain `status`, `payload`, `headers` and `url` properties.
   * The `url` property should be the final request URL after all redirects.
   *
   * Note: This element uses `URLSearchParams` class which is relatively new
   * interface in current browsers. You may need to provide a polyfill if you
   * are planning to use this component in older browsers.
   */
  class RequestDataExtractor extends
    HeadersParserMixin(
    Object) {

    /**
     * ARC request object
     */
    request: object|null|undefined;

    /**
     * ARC response object
     */
    response: object|null|undefined;

    /**
     * Source path delimiter
     */
    pathDelimiter: string|null|undefined;

    /**
     * Source data path. Either array of path segments
     * or full path as string.
     */
    path: Array<String|null>|String|null;

    /**
     * Gets the data from selected path.
     *
     * @param iterator Iterator model. Used only with response body.
     * @returns Data to be processed
     */
    extract(iterator: object|null): String|Number|null|undefined;

    /**
     * Returns the value for path for given source object
     *
     * @param url An url to parse.
     * @param path Path to the object
     * @returns Value for the path.
     */
    _getDataUrl(url: String|null, path: Array<String|null>|null): String|URLSearchParams|null;

    /**
     * Reads value of the URL query parameters.
     *
     * The `?` at the beginning of the query string is removed.
     *
     * @param url The URL object instance
     * @param param Param name to return. If not set then it returns
     * whole query string value.
     * @returns Full query string value if `param` is not set or paramter
     * value. This function does not returns `null` values.
     */
    _readUrlQueryValue(url: URL|null, param: String|null): String|null;

    /**
     * Reads value of the URL hash.
     *
     * The `#` at the beginning of the hash string is removed.
     *
     * If the `param` argument is set then it treats hahs value as a query
     * parameters string and parses it to get the value.
     *
     * @param url The URL object instance
     * @param param Param name to return. If not set then it returns
     * whole hash string value.
     * @returns Hash parameter or whole hash value.
     */
    _readUrlHashValue(url: URL|null, param: String|null): String|null;

    /**
     * Returns a value for the headers.
     *
     * @param source An object to read the url value from.
     * @param path Path to the object
     * @returns Value for the path.
     */
    _getDataHeaders(source: Request|Response|null, path: Array<String|null>|null): Headers|String|null;

    /**
     * Gets a value from a text for current path. Path is part of the
     * configuration object passed to the constructor.
     *
     * @param data Payload value.
     * @param contentType Body content type.
     * @param path Remaining path to follow
     * @param iterator Iterator model
     * @returns Value for given path.
     */
    _getPayloadValue(data: String|null, contentType: String|null, path: Array<String|null>|null, iterator: object|null): String|null|undefined;
  }
}

declare global {

  interface HTMLElementTagNameMap {
    "request-data-extractor": LogicElements.RequestDataExtractor;
  }
}
