/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   request-hooks-logic.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

export {RequestHooksLogic};

declare namespace LogicElements {

  /**
   * A component responsible for logic for ARC's request and responses actions.
   *
   * Actions are logical operations that the user can define in the request panel
   * which the result is assigned to a variable.
   */
  class RequestHooksLogic extends PolymerElement {

    /**
     * A reference name to the Jexl object.
     * Use dot notation to access it from the `window` object.
     * To set class pointer use `jexl` property.
     */
    jexlPath: string|null|undefined;

    /**
     * A Jexl class reference.
     * If this value is set it must be a pointer to the Jexl class and
     * `jexlPath` is ignored.
     * This property is set automatically when `jexlPath` is processed.
     */
    jexl: object|null|undefined;
    connectedCallback(): void;
    disconnectedCallback(): void;

    /**
     * A handler for the `run-response-actions` custom event.
     * It cancels the event and processes the actions.
     * See componnent description for event details info.
     */
    _handler(e: CustomEvent|null): void;

    /**
     * Processes actions when response object is ready.
     *
     * @param actions List of actions to perform
     * @param request ArcRequest object. See this doc for data model:
     * https://github.com/advanced-rest-client/api-components-api/blob/master/docs/api-request-and-response.md#api-request
     * @param response ArcResponse object. See this doc for data model:
     * https://github.com/advanced-rest-client/api-components-api/blob/master/docs/api-request-and-response.md#api-request
     * @returns A promise resolved when actions were performed.
     */
    processActions(actions: Array<object|null>|null, request: object|null, response: object|null): Promise<any>|null;
    _evaluateAction(action: any): any;

    /**
     * Creates a copy of the actio object.
     *
     * @param action Action model
     * @returns Deep copy of the action model.
     */
    _copyAction(action: object|null): object|null;

    /**
     * Creates instance of `request-logic-action` element, sets its properties and
     * inserts it into shadow DOM.
     *
     * @param action Action definition
     */
    _createLogicElement(action: object|null): Element|null;

    /**
     * Runs acrions recuresively until all actions are executed.
     *
     * @param actions Action definition
     * @param request ARC request object
     * @param response ARC response object
     */
    _runRecursive(actions: Array<object|null>|null, request: object|null, response: object|null): Promise<any>|null;
  }
}

declare global {

  interface HTMLElementTagNameMap {
    "request-hooks-logic": LogicElements.RequestHooksLogic;
  }
}
